package package_modele;
import java.awt.Color;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

import org.xml.sax.SAXException;

import package_vue.Panneau;
import package_vue.Vue;

public class Modele
{

	private PropertyChangeSupport PCS = new PropertyChangeSupport(this);
	private ArrayList<Tag> tags = new ArrayList<Tag>();
	private ArrayList<Fichier> fichiers = new ArrayList<Fichier>();

	
	private ArrayList<Tag> TousMesTags = new ArrayList <Tag>();
	private JFileChooser dialogue = new JFileChooser(new File("."));
	private int numBout =0;
    private File[] TagsDansOrganiDocs = new File(Config.CHEMIN_TAGS).listFiles();
    private int TailleOrganiDocs = TagsDansOrganiDocs.length;
    
    
    
    
    
	public Modele()
	{
		SaxParser epic = new SaxParser();
		try {
			TousMesTags = epic.Parser();
		} catch (SAXException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		System.out.println("LECTUREXML : trouve " + TousMesTags.size() + " tags");
		for(Tag t : TousMesTags)
		{
			System.out.println("tag = " + t.getnomTag() + " : " + t.getCouleur());
		}

	}
	public void init()
	{
		PCS.firePropertyChange(Vue.PROPERTY_RECENTS_TAGS, null, TousMesTags);
		PCS.firePropertyChange(Vue.PROPERTY_RECENTS, null, null); // On affiche les tags rcents
	}
	public void rechercher(String recherche)
	{
		
	
		if (recherche.equals(""))// si le champ Rechercher est vide un message d'erreur s'affiche 
		{
			JOptionPane.showMessageDialog(null, "Veuillez saisir le nom de votre Tag", "Erreur", JOptionPane.ERROR_MESSAGE);
		}
		else
		{
			String ch = Tag.toChemin(recherche); // Rcupre le chemin absolu du tag saisi dans le panneau de recherche
			if (ch!= null)
			{
				PCS.firePropertyChange(Vue.PROPERTY_LISTING, null, null); // On affiche le listing
				File[] ListeFichiersDansTags = Tag.rechercher_Tag(recherche);
				fichiers.clear();
				for (int j = 0; j < ListeFichiersDansTags.length; j++)
				{
					if (j >= 10) break; // On met que les 10 premiers fichiers
					fichiers.add(new Fichier(ListeFichiersDansTags[j]));
				}
				PCS.firePropertyChange(Vue.PROPERTY_LISTING_FICHIERS, null, fichiers); // On met  jour le listing de fichiers
				
				// DEBUT CHANGEMENT
				/*
				ArrayList<Tag> lstTags = new ArrayList<Tag>();
				Vector<Vector<String>> AutresTags = Tag.TagsAvecTagRecherche(ch);
				for(int c=0 ; c<AutresTags.size();c++)
				{
					for (int r=0; r < AutresTags.elementAt(c).size(); r++)
					{
						if (lstTags.size() > 5) break;
						boolean nouveau = true;
						String nomtag = AutresTags.elementAt(c).elementAt(r);
						for (Tag t : lstTags) { if (t.getnomTag().equals(nomtag)) { nouveau = false; break; } }
						if (nouveau)
						{
							Tag tag = new Tag(nomtag);
							tag.setCouleur(new Color(135,124,167));
							lstTags.add(tag);
						}
					}
				}
				*/
				//PCS.firePropertyChange(Vue.PROPERTY_LISTING_TAGS, null, lstTags); // On met  jour le listing de tags
				// FINCHANGEMENT
				PCS.firePropertyChange(Vue.PROPERTY_LISTING_TAGS, null, TousMesTags); // On met  jour le listing de tags
				
			}
			else
			{
				JOptionPane.showMessageDialog(null, "Ce Tag n'existe pas!", "Erreur", JOptionPane.ERROR_MESSAGE);
			}
		}
	}
	//PCS.firePropertyChange(Vue.PROPERTY_AJOUT_FICHIERS, null, fichiersAttente); // pour mettre  jour la liste des fichiers de la file d'attente sur l'interface
	public void parcourir()
	{
		dialogue = new JFileChooser(new File("."));
		if (dialogue.showOpenDialog(null)== JFileChooser.APPROVE_OPTION) 
		{
			File fichier = dialogue.getSelectedFile();
			PCS.firePropertyChange(Vue.PROPERTY_NEWTAG, null, fichier);
		}
	}
	public void newTag(File f, String NouveauDossierTag, Color c)
	{
		PCS.firePropertyChange(Vue.PROPERTY_RECENTS, null, null); // On affiche les tags rcents
		try
		{
			//sortie = new PrintWriter(new FileWriter(fichier.getPath(),true));
			//String NouveauDossierTag=JOptionPane.showInputDialog(null, "Veuillez choisir un Tag pour votre fichier", "Nouveau Tag", JOptionPane.QUESTION_MESSAGE);
			
			while(NouveauDossierTag.isEmpty())
			{
				JOptionPane.showMessageDialog (null, "Veuillez saisir le nom de votre Tag !", "Erreur", JOptionPane.ERROR_MESSAGE);
				NouveauDossierTag = JOptionPane.showInputDialog(null, "Veuillez choisir un Tag pour votre fichier", "Cration d'un nouveau Tag", JOptionPane.QUESTION_MESSAGE);
			}
			//si le tag existe dj 
			//toChemin retourne le chemin absolue du tag si celui ci existe sinon retourne nulll
			String nomTagToCheminTag = Tag.toChemin(NouveauDossierTag);
			System.out.println("NouveauDossierTag = " + NouveauDossierTag);
			System.out.println("nomTagToCheminTag = " + nomTagToCheminTag);
			if(!NouveauDossierTag.isEmpty()&&(nomTagToCheminTag !=null))
			{
				JOptionPane.showMessageDialog(null, "le Tag " + NouveauDossierTag+" existe dj et a t correctement attribu !"+f.getName(), "Ajout russi", JOptionPane.INFORMATION_MESSAGE);
				Tag.creerLienSymb (NouveauDossierTag,f);
				Tag montag = null; 
				for (Tag tag : TousMesTags) 
				{
					if (tag.getnomTag().equals(NouveauDossierTag) )
							{
						montag = tag; break;
						}
					}
				//TousMesTags.add( montag);
				montag.setCouleur(c); // maj de la couleur
				montag.liensSymbo.add(f.getAbsolutePath());// on ajoute  la liste des liens symbo
				 PCS.firePropertyChange(Vue.PROPERTY_RECENTS_TAGS, null, TousMesTags);

			}
			// si le tag n'existe pas
			if(!NouveauDossierTag.isEmpty()&&(nomTagToCheminTag == null))
			{
			
				//int TaillePanTagsRecents = inter.panneauTagsRecents.taille(); TODO
				//if (TaillePanTagsRecents > 5) PanTagsRecents.vider(); TODO
				Tag new_Tag = new  Tag(NouveauDossierTag);
				new_Tag.setCouleur(c);
				TousMesTags.add(new_Tag);
				Tag.creerLienSymb (NouveauDossierTag,f);
				new_Tag.liensSymbo.add(f.getAbsolutePath());// on ajoute  la liste des liens symbo

				JOptionPane.showMessageDialog(null, "le Tag " + NouveauDossierTag+" a t attribu  votre fichier" + f.getName(), "Ajout russi", JOptionPane.INFORMATION_MESSAGE);
				//Tag.toXml(TousMesTags);
				//mise  jour des couleurs
			}
			PCS.firePropertyChange(Vue.PROPERTY_RECENTS_TAGS, null, TousMesTags); // TODO pas utiliser tousmestags, mais genre TagsRecents ?
			Tag.toXml(TousMesTags);
		}
		catch(IOException e)
		{
			System.out.println("erreur : " + e);
		}
	}
	public void clicTag(String nom)
	{
		PCS.firePropertyChange(Vue.PROPERTY_RECHERCHE_AJOUT, null, nom);
	}
	public void clicTagRecent(String nom)
	{
		PCS.firePropertyChange(Vue.PROPERTY_RECHERCHE_AJOUT, null, nom);
	}
	
	public void addPropertyChangeListener(PropertyChangeListener listener)
	{
		PCS.addPropertyChangeListener(listener);
		init();
	}
	public void ajouter(File f)
	{
		PCS.firePropertyChange(Vue.PROPERTY_NEWTAG, null, f); // TODOfaire quand on clic sur une ligne de la file d'attente ?
		
		
		for (Fichier fi : fichiers) { if (fi.file == f) { fichiers.remove(fi); break; } }
		PCS.firePropertyChange(Vue.PROPERTY_AJOUT_FICHIERS, null, fichiers);
	}
	public void importer(List<File> files)
	{
		for(File f : files)
		{
			System.out.println("importer : " + f);
			boolean nouveau = true;
			for (Fichier fi : fichiers) { if (fi.nom.equals(f.getName())) { nouveau = false; break; } }
			if (nouveau) fichiers.add(new Fichier(f));
		}
		PCS.firePropertyChange(Vue.PROPERTY_AJOUT_FICHIERS, null, fichiers);
		
		
	}
	
	
	/* IGNORER, c'est juste pour tester l'interface
	 * IGNORER
	 * IGNORER
	 * IGNORER
	public void ajoutTag() // Fonction de test, ignorer
	{
		if (tags.size() > 4) tags.clear();
		tags.add(new Tag("UTC" + tags.size(),new Color(255,128,200)));
	}
	public void ajoutFichier() // Fonction de test, ignorer
	{
		if (fichiers.size() > 10) fichiers.clear();
		fichiers.add(new Fichier("C:\\test.txt","23/02/90","23Mo"));
	}
	public void rechercher(String s)
	{
		PCS.firePropertyChange(Vue.PROPERTY_LISTING, null, null); // Affichage du listing des fichiers et tags
		ajoutTag();
		PCS.firePropertyChange(Vue.PROPERTY_LISTING_TAGS, null, tags);
		ajoutFichier();
		PCS.firePropertyChange(Vue.PROPERTY_LISTING_FICHIERS, null, fichiers);
		PCS.firePropertyChange(Vue.PROPERTY_AJOUT_FICHIERS, null, fichiers);
	}
	public void parcourir()
	{
		PCS.firePropertyChange(Vue.PROPERTY_RECENTS, null, null); // Affichage des tags rcents
		ajoutTag();
		PCS.firePropertyChange(Vue.PROPERTY_RECENTS_TAGS, null, tags);
		ajoutFichier();
		PCS.firePropertyChange(Vue.PROPERTY_AJOUT_FICHIERS, null, fichiers);
	}
	*/
}
