package package_vue;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.JTextPane;
import javax.swing.TransferHandler;
import javax.swing.border.LineBorder;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;

import package_controleur.Controleur;

@SuppressWarnings("serial")
public class PanneauAjoutFichiers extends Panneau
{
	private static final String AJOUT = "Ajoutez des fichiers  l'aide du\nbouton parcourir\nou\nglissez/dposez les ici.";
	private JLabel lblFileDattente = new JLabel("FILED'ATTENTE");
	public JButton btnParcourir = new JButton("Parcourir");
    private JPanel panDeposerFichiers = new JPanel(new GridBagLayout());
    private Panneau panneauDepot = new Panneau();
    //private JLabel lblDeposerFichiers = new JLabel("Ajoutez des fichiers  l'aide du bouton parcourir ou glissez/dposez les ici.");
    private JTextPane taDeposerFichiers = new JTextPane();
    
    private ArrayList<FichierVue> lstFichiers = new ArrayList<FichierVue>();
    private JLabel lblNomFichier = new JLabel("Nom du fichier");
    private JLabel lblDateFichier = new JLabel("Date d'ajout");
    private JLabel lblTailleFichier = new JLabel("Taille");
	
    private Controleur controleur;
	public PanneauAjoutFichiers(Controleur c)
	{
		controleur = c;
		btnParcourir.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controleur.parcourir();
			}
    	});
		
		gbc.insets = new Insets(0, 20, 0, 20);
		//gbc.fill = GridBagConstraints.HORIZONTAL;
		//gbc.weightx = 1;
		// Label Ajout Fichiers
		
		//lblFileDattente.set
		lblFileDattente.setFont(Panneau.POLICE18b);
        add(lblFileDattente, gbc);
        
        // Bouton Parcourir
        gbc.anchor = GridBagConstraints.LINE_END;
        btnParcourir.setForeground(new Color(251,249,250));
        btnParcourir.setBackground(new Color(101,100,98));
        btnParcourir.setFont(Panneau.POLICE24);
        btnParcourir.setMargin(new Insets(0,6,0,6));
        add(btnParcourir, gbc);
        
        // Dept de Fichiers
        gbc.gridy = 1;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.weightx = 1;
        gbc.weighty = 1;
        gbc.insets = new Insets(0, 2, 0, 2);
        gbc.fill = GridBagConstraints.BOTH;
        panDeposerFichiers.setBorder(new LineBorder(new Color(100,100,100),2));
        panDeposerFichiers.setBackground(new Color(163,164,166));
        //panDeposerFichiers.setBackground(Color.BLACK);
        panDeposerFichiers.setPreferredSize(new Dimension(500,250));

        
        add(panDeposerFichiers, gbc);
        
        //panDeposerFichiers.add(lblDeposerFichiers);
        
        //taDeposerFichiers.setBorder(new LineBorder(new Color(100,100,100),2));
        taDeposerFichiers.setForeground(new Color(212,212,214));
        taDeposerFichiers.setBackground(new Color(163,164,166,0));
        //taDeposerFichiers.setPreferredSize(new Dimension(500,250));
        taDeposerFichiers.setFont(Panneau.POLICE24);
        taDeposerFichiers.setEditable(false);
        
        
        SimpleAttributeSet a = new SimpleAttributeSet();
        StyleConstants.setAlignment(a,StyleConstants.ALIGN_CENTER);
        StyleConstants.setForeground(a, new Color(212,212,214));
        StyleConstants.setFontFamily(a, Panneau.POLICE24.getFamily());
        StyleConstants.setFontSize(a, Panneau.POLICE24.getSize());
        //StyleConstants.setBold(a, true);
        StyleConstants.setItalic(a, true);
        //StyleConstants.setBackground(attributs, new Color(163,164,166));
        taDeposerFichiers.getStyledDocument().setParagraphAttributes(0, 0, a, true);
        taDeposerFichiers.setText(AJOUT);

        
        gbc = new GridBagConstraints();
        
        
        // Header Listing Fichiers
    	gbc.gridy = 0;
    	gbc.gridx = 0;
    	panDeposerFichiers.add(lblNomFichier, gbc);
        gbc.gridx = 1;
        gbc.weightx = 1;
        panDeposerFichiers.add(lblDateFichier, gbc);
        gbc.weightx = 0;
        gbc.gridx = 2;
        panDeposerFichiers.add(lblTailleFichier, gbc);
        
        // Separateur Listing Fichiers
        JSeparator sep = new JSeparator(JSeparator.HORIZONTAL);
        sep.setBorder(new LineBorder(new Color(100,100,100), 12));
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.gridx = 0;
        gbc.gridy = 1;
        panDeposerFichiers.add(sep, gbc);
        
        
        panneauDepot.add(taDeposerFichiers, panneauDepot.gbc);
		gbc.gridy++;
        gbc.weighty = 1;
        //panneauDepot.setBackground(Color.BLACK);
        //gbc.fill = GridBagConstraints.BOTH;
        gbc.anchor = GridBagConstraints.CENTER;
        panDeposerFichiers.add(panneauDepot, gbc);
        
        taDeposerFichiers.setDragEnabled(true);
        taDeposerFichiers.setTransferHandler(new TransferHandler()
        {
        	public boolean hasFileFlavor(DataFlavor[] df)
        	{
        		for (int i = 0; i < df.length; i++)
        		{
        			if (df[i].equals(DataFlavor.javaFileListFlavor)) return true;
        		}
        		return false;
        	}
        	public boolean canImport(JComponent cp, DataFlavor[] df)
        	{
        		return hasFileFlavor(df);
        	}
        	public boolean importData(JComponent cp, Transferable tr)
        	{
        		if (hasFileFlavor(tr.getTransferDataFlavors()))
        		{
        			try {
						controleur.importer(tr.getTransferData(DataFlavor.javaFileListFlavor));
					} catch (UnsupportedFlavorException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
        		}
        		return false;
        	}
        });
	}
	public void rafraichir()
	{
		panDeposerFichiers.remove(panneauDepot);
		//gbc = new GridBagConstraints();
		gbc.gridy++;
		gbc.gridx = 0;
        gbc.weighty = 1;
        gbc.weightx = 1;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        
        panDeposerFichiers.add(panneauDepot, gbc);
		getParent().validate();
	}
	public void vider()
	{
		for(FichierVue f : lstFichiers)
		{
			panDeposerFichiers.remove(f.nom);
			panDeposerFichiers.remove(f.date);
			panDeposerFichiers.remove(f.taille);
		}
		lstFichiers.clear();
		rafraichir();
	}
	public int taille() { return lstFichiers.size(); }
	public void ajouter(final File f, String nom, String date, String taille)
	{
    	JLabel lblNom = new JLabel(nom);
    	JLabel lblDate = new JLabel(date);
    	JLabel lblTaille = new JLabel(taille);
    	gbc = new GridBagConstraints();
    	gbc.weighty = 0;
    	gbc.gridx = 0;
    	gbc.gridy = lstFichiers.size() + 2;
    	gbc.anchor = GridBagConstraints.LINE_START;
    	lblNom.setBackground(Color.GREEN);
    	lblDate.setBackground(Color.GREEN);
    	lblTaille.setBackground(Color.GREEN);
    	
    	panDeposerFichiers.add(lblNom, gbc);
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.weightx = 1;
        gbc.gridx++;
        panDeposerFichiers.add(lblDate, gbc);
        gbc.weightx = 0;
        gbc.anchor = GridBagConstraints.LINE_END;
        gbc.gridx++;
        panDeposerFichiers.add(lblTaille, gbc);
        lstFichiers.add(new FichierVue(lblNom,lblDate,lblTaille));
        lblNom.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent arg0) {
				controleur.getModele().ajouter(f);
			}
			public void mouseEntered(MouseEvent arg0) {}
			public void mouseExited(MouseEvent arg0) {}
			public void mousePressed(MouseEvent arg0) {}
			public void mouseReleased(MouseEvent arg0) {}
		});
        rafraichir();
	}
}
