package package_vue;


import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JLabel;

import package_controleur.Controleur;

@SuppressWarnings("serial")
public class PanneauTags extends Panneau
{
	private JLabel lblTags = new JLabel("TAGS");
	private ArrayList<JButton> lstbtnTags = new ArrayList<JButton>();
	private Controleur controleur;
	public PanneauTags(Controleur c)
	{
		controleur = c;
		lblTags.setFont(Panneau.POLICE18b);
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(4,0,0,0);
		add(lblTags, gbc);
	}
	public void rafraichir()
	{
		getParent().getParent().validate();
	}
	public void vider()
	{
		for(JButton btn : lstbtnTags) remove(btn);
		lstbtnTags.clear();
		rafraichir();
	}
	public int taille() { return lstbtnTags.size(); }
	public void ajouter(final String nom, Color couleur)
	{
		BoutonTag btn = new BoutonTag(nom);
		btn.setColor(couleur);
		gbc = new GridBagConstraints();
        gbc.gridy = lstbtnTags.size() + 1;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.insets = new Insets(4,0,0,0);
        btn.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				controleur.clicTag(nom);
			}
		});
        add(btn, gbc);
        lstbtnTags.add(btn);
        rafraichir();
	}

}
