package package_vue;


import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JLabel;

import package_controleur.Controleur;

@SuppressWarnings("serial")
public class PanneauTagsRecents extends Panneau
{
	private JLabel lblTagsRecents = new JLabel("TAGS RCENTS");
	private ArrayList<JButton> lstbtnTagsRecents = new ArrayList<JButton>();
	private Controleur controleur;
	public PanneauTagsRecents(Controleur c)
	{
		controleur = c;
        gbc.gridx = 0;
        gbc.gridy = 0;
        //gbc.weightx = 5;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.LINE_START;
        //c.fill = GridBagConstraints.HORIZONTAL;
        lblTagsRecents.setFont(Panneau.POLICE18b);
        add(lblTagsRecents, gbc);
        gbc.anchor = GridBagConstraints.PAGE_START;
	}
	public void rafraichir()
	{
		getParent().validate();
	}
	public void vider()
	{
		for(JButton btn : lstbtnTagsRecents) remove(btn);
		lstbtnTagsRecents.clear();
		rafraichir();
	}
	public int taille() { return lstbtnTagsRecents.size(); }
	public void ajouter(final String nom, Color couleur)
	{
		BoutonTag btn = new BoutonTag(nom);
		btn.setColor(couleur);
		gbc = new GridBagConstraints();
        gbc.gridx = lstbtnTagsRecents.size() % 6;
        gbc.gridy = lstbtnTagsRecents.size() / 6 + 1;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.insets = new Insets(4,0,0,0);
        add(btn, gbc);
        btn.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				controleur.clicTagRecent(nom);
			}
		});
        lstbtnTagsRecents.add(btn);
        rafraichir();
	}
}
